input  = $1;	// prep output
output = $2;

cLinks = eset;
contain = eset;
$INSTANCE = eset;
cRefersTo = eset;
cRefersToExtern = eset;
cResolvedByExtern = eset;

getta (input);

toKeep = list;
for r in relnames { $r = $r; }
delete r;

///////////////////////////////////////////////////////////////////
///// Lowering process

nref = $INSTANCE . {"cNameRef"};
syms = $INSTANCE . {"cSymbol", "cObject", "cFunction"};
file = $INSTANCE . {"cExecutable", "cArchiveFile", "cObjectFile"};

flinkit = file o contain o file;
fLeaves = (rng flinkit - dom flinkit);
fLeaves = fLeaves + (file - ent flinkit);

s_n = syms o @name;
f_s = file o contain o syms;
leaves = fLeaves . f_s;

f_s_n = f_s ** s_n;
f_s_s_f = f_s_n o inv f_s_n;
f_s_s_f = f_s_s_f[flinkit &0 &3];
s_s = form(f_s_s_f, "&1", "&2");
S = s_s+; 

eLinks = cLinks o S o leaves;
eLinks = leaves o (inv S) o eLinks;
eLinks = eLinks + (leaves o cLinks o leaves);

nLinks = contain o cResolvedByExtern o cRefersToExtern;
nLinks = nLinks + (leaves o cLinks o leaves);

cLinks1 = eLinks ^ nLinks;

///////////////////////////////////////////////////////////////////
///// rawlink

nref = nref ^ (leaves . contain);
rawlink = nref o (cRefersTo + cResolvedByExtern o cRefersToExtern);
rawlink = (outdegree(rawlink) . {1}) o rawlink;
cLinks2 = contain o rawlink;

///////////////////////////////////////////////////////////////////

cLinks = cLinks1 + cLinks2;

///// Clean up
toDel = list - toKeep - {"syms", "leaves"};
for r in toDel { delete $r; }
delete r;

toDel = (syms - leaves) . (contain*);
delset(toDel);
delete syms;
delete leaves;

for r in relnames { if(#$r == 0) delete $r; }
delete r;

///////////////////////////////////////////////////////////////////
///// rawlink

rawlink = cRefersTo + cResolvedByExtern o cRefersToExtern;
rawlink = (outdegree(rawlink) . {1}) o rawlink;
cLinks  = cLinks + contain o rawlink;
delete rawlink;

putta(output, relnames);

