// CON: Contain

confile = $1;	// CONTAIN
alvfile = $2;	// ALV DATA
outfile = $3;

contain = eset;
getdb(confile);

///// Verify input contain.
ideg = indegree(contain);
ents = dom ideg - ideg . {1};
if(#ents > 0) {
    print "  Error[addcon.ql]: illegal contain";
    form(contain o ents, "    ", "&0", "&1");
    exit;
}
delete ideg;
delete ents;

confiles = rng contain - dom contain;

///// Read alv data
contain = eset;
getta(alvfile);

toSave = relnames;

files = $INSTANCE . {"cExecutable", "cObjectFile", "cArchiveFile"};

fcontain = contain o files;
contain = contain - fcontain;

alvfiles = dom contain - rng contain;

extra = confiles - alvfiles;
if(#extra > 0) {
    print "  Error[addcon.ql]: extra files included in contain";
    form(sort(extra), "    ", "&0");
    exit;
}

ignore = alvfiles - confiles;
if(#ignore > 0) {
    print "  Warning[addcon.ql]: files not included in contain were removed";
    form(sort(ignore), "    ", "&0");

    Do = contain*;
    delset(ignore . Do);
    delete Do;
}

delset(files - ent contain);

///////////////////////////////////////////////////////////////////////
///// Read contain file again to avoid the unexpected effect by delset.
getdb(confile);
$INSTANCE = $INSTANCE + (ent contain - dom $INSTANCE) X {"cSubSystem"};

putta(outfile, toSave);

